var AppBabylonBase = (function () {
    function AppBabylonBase() {
    }
    AppBabylonBase.prototype.render = function () {
        var _this = this;
        this.engine.runRenderLoop(function () {
            _this.scene.render();
            _this.stats.update();
            _this.statsMs.update();
        });
    };
    AppBabylonBase.prototype.registerResizeHandler = function () {
        var _this = this;
        window.addEventListener("resize", function () {
            _this.engine.resize();
        });
    };
    AppBabylonBase.prototype.addStats = function () {
        this.statsMs = new Stats();
        this.statsMs.setMode(1);
        document.body.appendChild(this.statsMs.domElement);
        this.statsMs.domElement.style.position = "absolute";
        this.statsMs.domElement.style.left = "10px";
        this.statsMs.domElement.style.top = "80px";
        this.stats = new Stats();
        document.body.appendChild(this.stats.domElement);
        this.stats.domElement.style.position = "absolute";
        this.stats.domElement.style.left = "10px";
        this.stats.domElement.style.top = "10px";
    };
    AppBabylonBase.prototype.createScene = function () {
        this.canvas = document.getElementById("canvas");
        this.canvas.width = window.innerWidth;
        this.canvas.height = window.innerHeight;
        this.engine = new BABYLON.Engine(this.canvas, true);
        this.scene = new BABYLON.Scene(this.engine);
        this.scene.clearColor = BABYLON.Color3.Black();
    };
    return AppBabylonBase;
})();
