var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppBabylonMaterials = (function (_super) {
    __extends(AppBabylonMaterials, _super);
    function AppBabylonMaterials() {
        _super.apply(this, arguments);
    }
    AppBabylonMaterials.prototype.main = function () {
        this.createScene();
        this.registerResizeHandler();
        this.addStats();
        this.addCamera();
        this.addLights();
        this.addObjects();
        this.render();
    };
    AppBabylonMaterials.prototype.addCamera = function () {
        this.camera = new BABYLON.ArcRotateCamera("camera", 3 * Math.PI / 2, Math.PI / 2, 5, new BABYLON.Vector3(0, 0, 0), this.scene);
        this.camera.position = new BABYLON.Vector3(0, 0, 1);
        this.scene.activeCamera.attachControl(this.canvas);
    };
    AppBabylonMaterials.prototype.addLights = function () {
        var light1 = new BABYLON.DirectionalLight("light1", new BABYLON.Vector3(-0.5, -0.5, 1), this.scene);
        light1.diffuse = new BABYLON.Color3(1, 1, 1);
        light1.specular = new BABYLON.Color3(1, 1, 1);
    };
    AppBabylonMaterials.prototype.addObjects = function () {
        var box = BABYLON.Mesh.CreateBox("box", 1.0, this.scene);
        box.rotation.y = -Math.PI / 6;
        var material = new BABYLON.StandardMaterial("material", this.scene);
        material.diffuseTexture = new BABYLON.Texture("../img/FIM.png", this.scene);
        box.material = material;
    };
    return AppBabylonMaterials;
})(AppBabylonBase);
window.onload = function () {
    var app = new AppBabylonMaterials();
    app.main();
};
