var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppBabylonObject = (function (_super) {
    __extends(AppBabylonObject, _super);
    function AppBabylonObject() {
        _super.apply(this, arguments);
    }
    AppBabylonObject.prototype.main = function () {
        this.createScene();
        this.registerResizeHandler();
        this.addStats();
        this.addCamera();
        this.addLights();
        this.addObjects();
        this.render();
    };
    AppBabylonObject.prototype.addLights = function () {
        var light1 = new BABYLON.DirectionalLight("light1", new BABYLON.Vector3(-0.5, -0.5, 1), this.scene);
        light1.diffuse = new BABYLON.Color3(1, 1, 1);
        light1.specular = new BABYLON.Color3(1, 1, 1);
        light1.intensity = 2;
        var light2 = new BABYLON.DirectionalLight("light1", new BABYLON.Vector3(0, 0, -1), this.scene);
        light2.diffuse = new BABYLON.Color3(1, 1, 1);
        light2.specular = new BABYLON.Color3(1, 1, 1);
        light2.intensity = 2;
    };
    AppBabylonObject.prototype.addCamera = function () {
        this.camera = new BABYLON.ArcRotateCamera("camera", 3 * Math.PI / 2, Math.PI / 2, 10, new BABYLON.Vector3(0, 0, 0), this.scene);
        this.camera.position = new BABYLON.Vector3(0, 0, 1);
        this.scene.activeCamera.attachControl(this.canvas);
    };
    AppBabylonObject.prototype.addObjects = function () {
        var _this = this;
        BABYLON.SceneLoader.ImportMesh("", "../objects/", "deer.babylon", this.scene, function (meshes) {
            _this.deer = meshes[0];
            _this.deer.position.y = -2;
            _this.deer.rotation.y = Math.PI / 6;
        });
        var material = new BABYLON.StandardMaterial("material", this.scene);
        material.diffuseColor = new BABYLON.Color3(0, 0.098, 0);
        material.specularColor = new BABYLON.Color3(0, 0, 0);
        material.specularPower = 0;
        var planeDown = BABYLON.Mesh.CreatePlane("planeDown", 4, this.scene);
        planeDown.position.y = -2;
        planeDown.scaling.x = 1.5;
        planeDown.rotation.x = Math.PI / 2;
        planeDown.material = material;
    };
    return AppBabylonObject;
})(AppBabylonBase);
window.onload = function () {
    var app = new AppBabylonObject();
    app.main();
};
