var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppSceneFps = (function (_super) {
    __extends(AppSceneFps, _super);
    function AppSceneFps() {
        var _this = this;
        _super.apply(this, arguments);
        this.cubes = [];
        this.controls = new Controls(function () { return _this.changeCubesCount(false); }, function () { return _this.changeCubesCount(true); });
        this.testCounts = [1, 50, 500, 1000, 2000, 5000];
    }
    AppSceneFps.prototype.main = function () {
        var gui = document.createElement("div");
        gui.id = "gui-container";
        document.body.appendChild(gui);
        this.createScene();
        this.addStats();
        this.addControls();
        this.addCubes(this.controls.cubesCount);
        this.renderWithAnimation();
    };
    AppSceneFps.prototype.renderWithAnimation = function () {
        var _this = this;
        requestAnimationFrame(function () { return _this.renderWithAnimation(); });
        if (this.controls.animation) {
            for (var i = 0; i < this.cubes.length; i++) {
                switch (i % 3) {
                    case 0:
                        this.scene.getNode("rotateX" + (i).toString(), function (rotateX) {
                            rotateX.setAngle(rotateX.getAngle() + 1.0);
                        });
                        break;
                    case 1:
                        this.scene.getNode("rotateY" + (i).toString(), function (rotateY) {
                            rotateY.setAngle(rotateY.getAngle() + 1.0);
                        });
                        break;
                    case 2:
                        this.scene.getNode("rotateZ" + (i).toString(), function (rotateZ) {
                            rotateZ.setAngle(rotateZ.getAngle() + 1.0);
                        });
                        break;
                }
            }
        }
        this.stats.update();
        this.statsMs.update();
    };
    AppSceneFps.prototype.createScene = function () {
        this.scene = SceneJS.createScene({
            nodes: [
                {
                    type: "cameras/orbit",
                    eye: {
                        x: 0,
                        y: 0,
                        z: 1
                    },
                    zoom: 40,
                    look: { x: 0, y: 0, z: 0 },
                    nodes: [
                        {
                            type: "renderer",
                            clearColor: { r: 0, g: 0, b: 0 },
                            clear: {
                                depth: true,
                                color: true
                            },
                            nodes: [
                                {
                                    type: "lights",
                                    lights: [
                                        {
                                            mode: "dir",
                                            color: { r: 1.0, g: 1.0, b: 1.0 },
                                            diffuse: true,
                                            specular: false,
                                            dir: { x: -0.5, y: -0.5, z: -1.0 },
                                            space: "world"
                                        }
                                    ],
                                    nodes: [
                                        {
                                            type: "material",
                                            color: { r: 1, g: 0, b: 0 },
                                            nodes: [
                                                {
                                                    type: "node",
                                                    id: "cubes"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });
    };
    AppSceneFps.prototype.addControls = function () {
        var _this = this;
        var gui = new dat.GUI();
        var controller = gui.add(this.controls, 'cubesCount', 1, 5000).step(1);
        controller.setName('Počet krychlí');
        var controllerPre = gui.add(this.controls, 'cubesCount', [1, 50, 500, 1000, 2000, 5000]);
        controllerPre.setName('Počet krychlí');
        var controllerAnimation = gui.add(this.controls, 'animation');
        controllerAnimation.setName('Animace');
        var controllerTest = gui.add(this.controls, 'test');
        controllerTest.setName('Test');
        var controllerTestAnimated = gui.add(this.controls, 'testAnimated');
        controllerTestAnimated.setName('Test - animace');
        controller.onFinishChange(function (value) { return _this.addCubes(value); });
        controllerPre.onFinishChange(function (value) { return _this.addCubes(value); });
    };
    AppSceneFps.prototype.addCubes = function (cubesCount) {
        var _this = this;
        this.addStats();
        while (this.cubes.length > 0) {
            var cube = this.cubes.pop();
            cube.name.destroy();
        }
        var addedCubesCount = 0;
        var squareSize = Math.ceil(Math.sqrt(cubesCount));
        var xdelta = 40 / squareSize;
        var ydelta = 30 / squareSize;
        var startk = Math.floor(-squareSize / 2);
        for (var k = startk; k < startk + squareSize; k++) {
            var startl = Math.floor(-squareSize / 2);
            for (var l = startl; l < startl + squareSize; l++) {
                if (addedCubesCount < cubesCount) {
                    var innerL = (l + 1) * xdelta;
                    var innerK = (k + 1) * ydelta;
                    var randomX = Math.random() * 360;
                    var randomY = Math.random() * 360;
                    var randomZ = Math.random() * 360;
                    this.scene.getNode("cubes", function (cubeNode) {
                        var cube = {
                            name: cubeNode.addNode({
                                type: "name",
                                name: addedCubesCount.toString(),
                                nodes: [
                                    {
                                        type: "material",
                                        color: { r: 0.35, g: 0.76, b: 0.8 },
                                        nodes: [
                                            {
                                                type: "translate",
                                                x: innerL,
                                                y: innerK,
                                                z: 0,
                                                nodes: [
                                                    {
                                                        type: "rotate",
                                                        id: "rotateX" + addedCubesCount.toString(),
                                                        angle: randomX,
                                                        x: 1,
                                                        nodes: [
                                                            {
                                                                type: "rotate",
                                                                id: "rotateY" + addedCubesCount.toString(),
                                                                angle: randomY,
                                                                y: 1,
                                                                nodes: [
                                                                    {
                                                                        type: "rotate",
                                                                        id: "rotateZ" + addedCubesCount.toString(),
                                                                        angle: randomZ,
                                                                        z: 1,
                                                                        nodes: [
                                                                            {
                                                                                type: "geometry/box",
                                                                                xSize: 1,
                                                                                ySize: 1,
                                                                                zSize: 1
                                                                            }
                                                                        ]
                                                                    }
                                                                ]
                                                            }
                                                        ]
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ]
                            })
                        };
                        addedCubesCount++;
                        _this.cubes.push(cube);
                    });
                }
                else {
                    break;
                }
            }
        }
    };
    AppSceneFps.prototype.changeCubesCount = function (animated) {
        var self = this;
        if (!animated) {
            self.controls.animation = false;
        }
        else {
            self.controls.animation = true;
        }
        for (var i = 0; i <= self.testCounts.length; i++)
            setTimeout(function (j) {
                if (j > 0) {
                    var medianFps = self.stats.getFpsMedian();
                    var medianMs = self.stats.getMsMedian();
                    console.log(self.testCounts[j - 1] + ": " + medianFps.toString() + ", " + medianMs.toString());
                    if (j === self.testCounts.length) {
                        alert("Test dokončen.");
                        self.addCubes(self.testCounts[0]);
                        self.controls.animation = false;
                    }
                }
                if (j < self.testCounts.length) {
                    self.addCubes(self.testCounts[j]);
                }
            }, 10000 * i, i);
    };
    AppSceneFps.prototype.writeFps = function (count) {
        var self = this;
        setTimeout(function (j) {
            var medianFps = self.stats.getFpsMedian();
            var medianMs = self.stats.getMsMedian();
            console.log(j.toString() + ": " + medianFps.toString() + ", " + medianMs.toString());
        }, 17000, count);
    };
    return AppSceneFps;
})(AppSceneBase);
window.onload = function () {
    var app = new AppSceneFps();
    app.main();
};
