var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppSceneGeometry = (function (_super) {
    __extends(AppSceneGeometry, _super);
    function AppSceneGeometry() {
        _super.apply(this, arguments);
    }
    AppSceneGeometry.prototype.main = function () {
        this.createScene();
        this.addStats();
        this.render();
    };
    AppSceneGeometry.prototype.createScene = function () {
        this.scene = SceneJS.createScene({
            nodes: [
                {
                    type: "cameras/orbit",
                    eye: {
                        x: 0,
                        y: 0,
                        z: 1
                    },
                    zoom: 20,
                    look: { x: 0, y: 0, z: 0 },
                    nodes: [
                        {
                            type: "renderer",
                            clearColor: { r: 0, g: 0, b: 0 },
                            clear: {
                                depth: true,
                                color: true
                            },
                            nodes: [
                                {
                                    type: "lights",
                                    lights: [
                                        {
                                            mode: "dir",
                                            color: { r: 1.0, g: 1.0, b: 1.0 },
                                            diffuse: true,
                                            specular: true,
                                            dir: { x: -0.5, y: -0.5, z: -1.0 },
                                            space: "world"
                                        }
                                    ],
                                    nodes: [
                                        {
                                            type: "material",
                                            color: { r: 1, g: 0, b: 0 },
                                            shine: 100,
                                            nodes: [
                                                {
                                                    type: "translate",
                                                    x: -2,
                                                    y: 0,
                                                    z: 0,
                                                    nodes: [
                                                        {
                                                            type: "geometry/box",
                                                            xSize: 1,
                                                            ySize: 1,
                                                            zSize: 1
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            type: "material",
                                            color: { r: 0, g: 1, b: 0 },
                                            nodes: [
                                                {
                                                    type: "translate",
                                                    x: 2,
                                                    y: 0,
                                                    z: 0,
                                                    nodes: [
                                                        {
                                                            type: "geometry/cylinder",
                                                            radiusTop: 0.5,
                                                            radiusBottom: 0.5,
                                                            height: 2
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            type: "material",
                                            color: { r: 0, g: 0, b: 2 },
                                            nodes: [
                                                {
                                                    type: "translate",
                                                    x: 6,
                                                    y: 0,
                                                    z: 0,
                                                    nodes: [
                                                        {
                                                            type: "geometry/torus",
                                                            radius: 0.8,
                                                            tube: 0.4
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            type: "material",
                                            color: { r: 1, g: 1, b: 0 },
                                            nodes: [
                                                {
                                                    type: "translate",
                                                    x: -6,
                                                    y: 0,
                                                    z: 0,
                                                    nodes: [
                                                        {
                                                            type: "geometry/sphere"
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });
    };
    return AppSceneGeometry;
})(AppSceneBase);
window.onload = function () {
    var app = new AppSceneGeometry();
    app.main();
};
