var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppSceneLights = (function (_super) {
    __extends(AppSceneLights, _super);
    function AppSceneLights() {
        _super.apply(this, arguments);
    }
    AppSceneLights.prototype.main = function () {
        this.createScene();
        this.addStats();
        this.render();
    };
    AppSceneLights.prototype.createScene = function () {
        this.scene = SceneJS.createScene({
            nodes: [
                {
                    type: "cameras/orbit",
                    eye: {
                        x: 0,
                        y: 0,
                        z: 1
                    },
                    zoom: 10,
                    look: { x: 0, y: 0, z: 0 },
                    nodes: [
                        {
                            type: "renderer",
                            clearColor: { r: 0, g: 0, b: 0 },
                            clear: {
                                depth: true,
                                color: true
                            },
                            nodes: [
                                {
                                    type: "lights",
                                    lights: [
                                        {
                                            mode: "dir",
                                            color: { r: 0.016, g: 0.506, b: 0.62 },
                                            diffuse: true,
                                            specular: true,
                                            dir: { x: 1.5, y: 0, z: 0 },
                                            space: "world"
                                        },
                                        {
                                            mode: "point",
                                            color: { r: 1, g: 0.498, b: 0 },
                                            diffuse: true,
                                            specular: true,
                                            pos: { x: 1.5, y: 0, z: 0 },
                                            space: "world"
                                        }
                                    ],
                                    nodes: [
                                        {
                                            type: "material",
                                            color: { r: 1.0, g: 1.0, b: 1.0 },
                                            specular: 0.5,
                                            shine: 19.0,
                                            nodes: [
                                                {
                                                    type: "geometry/sphere",
                                                    radius: 0.7
                                                },
                                                {
                                                    type: "translate",
                                                    y: -2,
                                                    nodes: [
                                                        {
                                                            type: "rotate",
                                                            angle: -90,
                                                            x: 1,
                                                            nodes: [
                                                                {
                                                                    type: "geometry/plane",
                                                                    width: 6,
                                                                    height: 4,
                                                                    widthSegments: 2,
                                                                    heightSegments: 1
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                },
                                                {
                                                    type: "translate",
                                                    z: -2,
                                                    nodes: [
                                                        {
                                                            type: "geometry/plane",
                                                            width: 6,
                                                            height: 4,
                                                            widthSegments: 2,
                                                            heightSegments: 1
                                                        }
                                                    ]
                                                },
                                                {
                                                    type: "translate",
                                                    x: 3,
                                                    nodes: [
                                                        {
                                                            type: "rotate",
                                                            angle: -90,
                                                            y: 1,
                                                            nodes: [
                                                                {
                                                                    type: "geometry/plane",
                                                                    width: 4,
                                                                    height: 4,
                                                                    widthSegments: 1,
                                                                    heightSegments: 1
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                },
                                                {
                                                    type: "translate",
                                                    x: -3,
                                                    nodes: [
                                                        {
                                                            type: "rotate",
                                                            angle: 90,
                                                            y: 1,
                                                            nodes: [
                                                                {
                                                                    type: "geometry/plane",
                                                                    width: 4,
                                                                    height: 4,
                                                                    widthSegments: 1,
                                                                    heightSegments: 1
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });
    };
    return AppSceneLights;
})(AppSceneBase);
window.onload = function () {
    var app = new AppSceneLights();
    app.main();
};
