var AppThreeBase = (function () {
    function AppThreeBase() {
    }
    AppThreeBase.prototype.registerResizeHandler = function () {
        var _this = this;
        window.addEventListener('resize', function () {
            if (!_this.renderer || !_this.camera || !_this.camera['aspect'] || !_this.camera['updateProjectionMatrix'])
                return;
            _this.renderer.setSize(window.innerWidth, window.innerHeight);
            _this.camera.aspect = window.innerWidth / window.innerHeight;
            _this.camera.updateProjectionMatrix();
        }, false);
    };
    AppThreeBase.prototype.render = function () {
        var _this = this;
        requestAnimationFrame(function () { return _this.render(); });
        this.stats.update();
        this.statsMs.update();
        this.renderer.render(this.scene, this.camera);
    };
    AppThreeBase.prototype.addStats = function () {
        this.statsMs = new Stats();
        this.statsMs.setMode(1);
        document.body.appendChild(this.statsMs.domElement);
        this.statsMs.domElement.style.position = "absolute";
        this.statsMs.domElement.style.left = "10px";
        this.statsMs.domElement.style.top = "80px";
        this.stats = new Stats();
        document.body.appendChild(this.stats.domElement);
        this.stats.domElement.style.position = "absolute";
        this.stats.domElement.style.left = "10px";
        this.stats.domElement.style.top = "10px";
    };
    AppThreeBase.prototype.createScene = function () {
        this.scene = new THREE.Scene();
        this.renderer = new THREE.WebGLRenderer({ clearColor: 0x000000, alpha: true });
        this.renderer.setClearColor(new THREE.Color(0x000000));
        this.renderer.setSize(window.innerWidth, window.innerHeight);
        document.body.appendChild(this.renderer.domElement);
        var orbitControls = new THREE.OrbitControls(this.camera, this.renderer.domElement);
    };
    return AppThreeBase;
})();
