var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppThreeGeometry = (function (_super) {
    __extends(AppThreeGeometry, _super);
    function AppThreeGeometry() {
        _super.call(this);
    }
    AppThreeGeometry.prototype.main = function () {
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);
        this.createScene();
        this.addStats();
        this.addLights();
        this.addObjects();
        this.registerResizeHandler();
        this.render();
    };
    AppThreeGeometry.prototype.addLights = function () {
        var light = new THREE.DirectionalLight(0xffffff, 1);
        light.position.set(0.5, 0.5, 1);
        this.scene.add(light);
    };
    AppThreeGeometry.prototype.addObjects = function () {
        var cube = new THREE.Mesh(new THREE.BoxGeometry(1, 1, 1), new THREE.MeshPhongMaterial({ color: 0xff0000 }));
        cube.position.x = -1;
        cube.position.z = 0;
        this.scene.add(cube);
        var sphere = new THREE.Mesh(new THREE.SphereGeometry(0.5, 30, 30), new THREE.MeshPhongMaterial({ color: 0xffff00 }));
        sphere.position.x = -3;
        sphere.position.z = 0;
        this.scene.add(sphere);
        var cylinder = new THREE.Mesh(new THREE.CylinderGeometry(0.25, 0.25, 1, 30, 30), new THREE.MeshPhongMaterial({ color: 0x00ff00 }));
        cylinder.position.x = 1;
        cylinder.position.z = 0;
        this.scene.add(cylinder);
        var torus = new THREE.Mesh(new THREE.TorusGeometry(0.4, 0.2, 30, 30), new THREE.MeshPhongMaterial({ color: 0x0000ff }));
        torus.position.x = 3;
        torus.position.z = 0;
        this.scene.add(torus);
    };
    return AppThreeGeometry;
})(AppThreeBase);
window.onload = function () {
    var app = new AppThreeGeometry();
    app.main();
};
