var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppThreeLights = (function (_super) {
    __extends(AppThreeLights, _super);
    function AppThreeLights() {
        _super.call(this);
    }
    AppThreeLights.prototype.main = function () {
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);
        this.createScene();
        this.addStats();
        this.addObjects();
        this.addLights();
        this.registerResizeHandler();
        this.render();
    };
    AppThreeLights.prototype.addLights = function () {
        var lightDir = new THREE.DirectionalLight(0x04819E, 1);
        lightDir.position.set(-1.5, 0, 0);
        this.scene.add(lightDir);
        var pointLight = new THREE.PointLight(0xFF7F00, 1);
        pointLight.position.set(1.5, 0, 0);
        this.scene.add(pointLight);
    };
    AppThreeLights.prototype.addObjects = function () {
        var material = new THREE.MeshPhongMaterial();
        material.shininess = 70;
        var sphere = new THREE.Mesh(new THREE.SphereGeometry(0.7, 40, 40), material);
        this.scene.add(sphere);
        var geometry = new THREE.PlaneGeometry(6, 4);
        var plane = new THREE.Mesh(geometry, material);
        plane.position.y = -2;
        plane.rotation.x = -Math.PI / 2;
        this.scene.add(plane);
        var plane2 = new THREE.Mesh(geometry, material);
        plane2.position.z = -2;
        this.scene.add(plane2);
        var geometry2 = new THREE.PlaneGeometry(4, 4);
        var plane3 = new THREE.Mesh(geometry2, material);
        plane3.rotation.y = -Math.PI / 2;
        plane3.position.x = 3;
        this.scene.add(plane3);
        var plane4 = new THREE.Mesh(geometry2, material);
        plane4.rotation.y = Math.PI / 2;
        plane4.position.x = -3;
        this.scene.add(plane4);
    };
    return AppThreeLights;
})(AppThreeBase);
window.onload = function () {
    var app = new AppThreeLights();
    app.main();
};
