var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var AppThreeObject = (function (_super) {
    __extends(AppThreeObject, _super);
    function AppThreeObject() {
        _super.call(this);
    }
    AppThreeObject.prototype.main = function () {
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);
        this.createScene();
        this.addStats();
        this.addLights();
        this.addObjects();
        this.registerResizeHandler();
        this.render();
    };
    AppThreeObject.prototype.addLights = function () {
        var light = new THREE.DirectionalLight(0xffffff, 2);
        light.position.set(0.5, 0.5, 1);
        this.scene.add(light);
        var light2 = new THREE.DirectionalLight(0xffffff, 2);
        light2.position.set(0, 0, -1);
        this.scene.add(light2);
    };
    AppThreeObject.prototype.addObjects = function () {
        var _this = this;
        var loader = new THREE.JSONLoader();
        loader.load('../objects/deer.json', function (geometry, materials) {
            var material = new THREE.MeshFaceMaterial(materials);
            var deer = new THREE.Mesh(geometry, material);
            deer.position.y = -2;
            deer.rotation.y = -Math.PI / 6;
            _this.scene.add(deer);
        });
        var material = new THREE.MeshLambertMaterial({ color: 0x001900 });
        var geometry = new THREE.PlaneGeometry(6, 4);
        var plane = new THREE.Mesh(geometry, material);
        plane.position.y = -2;
        plane.rotation.x = -Math.PI / 2;
        this.scene.add(plane);
    };
    return AppThreeObject;
})(AppThreeBase);
window.onload = function () {
    var app = new AppThreeObject();
    app.main();
};
