﻿/// <reference path="../decl/babylon.2.0.d.ts" />
/// <reference path="../decl/cannon.d.ts" />

class AppBabylonObject extends AppBabylonBase {
    public deer: BABYLON.AbstractMesh;

    public main() {
        this.createScene();
        this.registerResizeHandler();

        this.addStats();
        this.addCamera();
        this.addLights();
        this.addObjects();

        this.render();
    }

    /*
    Prida svetla do sceny. 
    */
    addLights() {
        var light1 = new BABYLON.DirectionalLight("light1", new BABYLON.Vector3(-0.5, -0.5, 1), this.scene);
        light1.diffuse = new BABYLON.Color3(1, 1, 1);
        light1.specular = new BABYLON.Color3(1, 1, 1);
        light1.intensity = 2;

        var light2 = new BABYLON.DirectionalLight("light1", new BABYLON.Vector3(0, 0, -1), this.scene);
        light2.diffuse = new BABYLON.Color3(1, 1, 1);
        light2.specular = new BABYLON.Color3(1, 1, 1);
        light2.intensity = 2;
    }

    /*
    Prida kameru. 
    */
    addCamera() {
        this.camera = new BABYLON.ArcRotateCamera
            ("camera", 3 * Math.PI / 2, Math.PI / 2, 10, new BABYLON.Vector3(0, 0, 0), this.scene);
        this.camera.position = new BABYLON.Vector3(0, 0, 1);
        this.scene.activeCamera.attachControl(this.canvas);
    }

    addObjects() {
        BABYLON.SceneLoader.ImportMesh("", "../objects/", "deer.babylon", this.scene,(meshes) => {
            this.deer = meshes[0];
            this.deer.position.y = -2;
            this.deer.rotation.y = Math.PI / 6;
        });

        var material = new BABYLON.StandardMaterial("material", this.scene);
        material.diffuseColor = new BABYLON.Color3(0, 0.098, 0);
        material.specularColor = new BABYLON.Color3(0, 0, 0);
        material.specularPower = 0;

        var planeDown = BABYLON.Mesh.CreatePlane("planeDown", 4, this.scene);
        planeDown.position.y = -2;
        planeDown.scaling.x = 1.5;
        planeDown.rotation.x = Math.PI / 2;
        planeDown.material = material;
    }
}

window.onload = () => {
    var app = new AppBabylonObject();
    app.main();
}; 