﻿declare var SceneJS

class AppSceneMaterials extends AppSceneBase {

    public main() {
        this.createScene();

        this.addStats();
        this.render();
    }

    createScene() {
    this.scene = SceneJS.createScene({
        nodes: [
            {
                type: "cameras/orbit",
                eye: {
                    x: 0,
                    y: 0,
                    z: 1
                },
                zoom: 10,
                look: { x: 0, y: 0, z: 0 },
                nodes: [
                    {
                        type: "renderer",
                        clearColor: { r: 0, g: 0, b: 0 },
                        clear: {
                            depth: true,
                            color: true
                        },
                        nodes: [
                            {
                                type: "lights",
                                lights: [
                                    {
                                        mode: "dir",
                                        color: { r: 1.0, g: 1.0, b: 1.0 },
                                        diffuse: true,
                                        specular: true,
                                        dir: { x: -0.5, y: -0.5, z: -1.0 },
                                        space: "world"
                                    }
                                ],

                                nodes: [
                                    {
                                        type: "material",
                                        specular: 0,
                                        nodes: [
                                            {
                                                type: "texture",
                                                src: "../img/FIM.png",
                                                applyTo: "color",

                                                nodes: [
                                                    {
                                                        type: "translate",
                                                        x: 0,
                                                        y: 0,
                                                        z: 0,
                                                        nodes: [
                                                            {
                                                                type: "rotate",
                                                                angle: 30,
                                                                y: 1,

                                                                nodes: [
                                                                    {
                                                                        type: "geometry/box",
                                                                        xSize: 1,
                                                                        ySize: 1,
                                                                        zSize: 1
                                                                    }
                                                                ]
                                                            }
                                                        ]
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ]
                            }
                        ]
                    }
                ]
            }
        ]
    }); }
}

window.onload = () => {
    var app = new AppSceneMaterials();
    app.main();
};

