﻿declare var SceneJS

class AppSceneObject extends AppSceneBase {

    public main() {
        this.createScene();

        this.addStats();
        this.render();
    }

    createScene() {
        this.scene = SceneJS.createScene({
            nodes: [
                {
                    type: "cameras/orbit",
                    eye: {
                        x: 0,
                        y: 0,
                        z: 1
                    },
                    zoom: 10,
                    look: { x: 0, y: 0, z: 0 },
                    nodes: [
                        {
                            type: "renderer",
                            clearColor: { r: 0, g: 0, b: 0 },
                            clear: {
                                depth: true,
                                color: true
                            },
                            nodes: [
                                {
                                    type: "lights",
                                    lights: [
                                        {
                                            mode: "dir",
                                            color: { r: 1.0, g: 1.0, b: 1.0 },
                                            diffuse: true,
                                            specular: false,
                                            dir: { x: -0.5, y: -0.5, z: -1.0 },
                                            space: "world"
                                        },
                                        {
                                            mode: "dir",
                                            color: { r: 1.0, g: 1.0, b: 1.0 },
                                            diffuse: true,
                                            specular: false,
                                            dir: { x: 0, y: 0, z: 1 },
                                            space: "world"
                                        }
                                    ],

                                    nodes: [
                                        {
                                            type: "translate",
                                            y: -2,
                                            nodes: [
                                                {
                                                    type: "rotate",
                                                    angle: -30,
                                                    y: 1,
                                                    nodes: [
                                                        {
                                                            type: "texture",
                                                            src: "../objects/Deer_body_D.png",

                                                            nodes: [
                                                                {
                                                                    type: "import/obj",
                                                                    src: "../objects/Deer.obj"
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            type: "material",
                                            color: { r: 0, g: 0.098, b: 0 },
                                            nodes: [
                                                {
                                                    type: "translate",
                                                    y: -2,
                                                    nodes: [
                                                        {
                                                            type: "rotate",
                                                            angle: -90,
                                                            x: 1,
                                                            nodes: [
                                                                {
                                                                    type: "geometry/plane",
                                                                    width: 6,
                                                                    height: 4,
                                                                    widthSegments: 2,
                                                                    heightSegments: 1
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });
    }
}

window.onload = () => {
    var app = new AppSceneObject();
    app.main();
};