﻿/// <reference path="../decl/three.d.ts" />
/// <reference path="../decl/three-orbitcontrols.d.ts" />
/// <reference path="../decl/dat-gui.d.ts" />
/// <reference path="appthreebase.ts" />

class AppThreeGeometry extends AppThreeBase {

    constructor() {
        super();
    }

    public main() {

        // kamera
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);

        this.createScene();
        this.addStats();

        this.addLights();
        this.addObjects();

        // prizbusobeni oknu
        this.registerResizeHandler();

        // vykresleni
        this.render();
    }

    /*
    Prida svetla do sceny. 
    */
    addLights() {
        // bodove svetlo
        var light = new THREE.DirectionalLight(0xffffff, 1);
        light.position.set(0.5, 0.5, 1);
        this.scene.add(light);
    }

    /*
    Prida objekty do sceny. 
    */
    addObjects() {
        // kostka
        var cube = new THREE.Mesh(
            new THREE.BoxGeometry(1, 1, 1),
            new THREE.MeshPhongMaterial({ color: 0xff0000 }));

        cube.position.x = -1;
        cube.position.z = 0;

        this.scene.add(cube);

        // koule
        var sphere = new THREE.Mesh(
            new THREE.SphereGeometry(0.5, 30, 30),
            new THREE.MeshPhongMaterial({ color: 0xffff00 }));

        sphere.position.x = -3;
        sphere.position.z = 0;

        this.scene.add(sphere);

        // valec
        var cylinder = new THREE.Mesh(
            new THREE.CylinderGeometry(0.25, 0.25, 1, 30, 30),
            new THREE.MeshPhongMaterial({ color: 0x00ff00 }));

        cylinder.position.x = 1;
        cylinder.position.z = 0;

        this.scene.add(cylinder);

        // torus
        var torus = new THREE.Mesh(
            new THREE.TorusGeometry(0.4, 0.2, 30, 30),
            new THREE.MeshPhongMaterial({ color: 0x0000ff }));

        torus.position.x = 3;
        torus.position.z = 0;

        this.scene.add(torus);
    }
}

window.onload = () => {
    var app = new AppThreeGeometry();
    app.main();
}; 