﻿/// <reference path="../decl/three.d.ts" />
/// <reference path="../decl/three-orbitcontrols.d.ts" />
/// <reference path="../decl/dat-gui.d.ts" />
/// <reference path="appthreebase.ts" />

class AppThreeLights extends AppThreeBase {

    constructor() {
        super();
    }

    public main() {

        // kamera
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);

        this.createScene();
        this.addStats();
        this.addObjects();
        this.addLights();


        // prizbusobeni oknu
        this.registerResizeHandler();

        // vykresleni
        this.render();
    }

    /*
    Prida svetla do sceny. 
    */
    addLights() {
        // smerove svetlo
        var lightDir = new THREE.DirectionalLight(0x04819E, 1);
        lightDir.position.set(-1.5, 0, 0);
        this.scene.add(lightDir);

        // bodove svetlo
        var pointLight = new THREE.PointLight(0xFF7F00, 1);
        pointLight.position.set(1.5, 0, 0);
        this.scene.add(pointLight);
    }

    /*
    Prida objekty do sceny. 
    */
    addObjects() {
        var material = new THREE.MeshPhongMaterial();
        material.shininess = 70;

        // koule
        var sphere = new THREE.Mesh(
            new THREE.SphereGeometry(0.7, 40, 40),
            material);

        this.scene.add(sphere);

        // obdelniky
        var geometry = new THREE.PlaneGeometry(6, 4);

        var plane = new THREE.Mesh(geometry, material);
        plane.position.y = -2;
        plane.rotation.x = - Math.PI / 2;
        this.scene.add(plane);

        var plane2 = new THREE.Mesh(geometry, material);
        plane2.position.z = -2;
        this.scene.add(plane2);

        var geometry2 = new THREE.PlaneGeometry(4, 4);
        var plane3 = new THREE.Mesh(geometry2, material);
        plane3.rotation.y = - Math.PI / 2;
        plane3.position.x = 3;
        this.scene.add(plane3);

        var plane4 = new THREE.Mesh(geometry2, material);
        plane4.rotation.y = Math.PI / 2;
        plane4.position.x = -3;
        this.scene.add(plane4);
    }
}

window.onload = () => {
    var app = new AppThreeLights();
    app.main();
}; 