﻿/// <reference path="../decl/three.d.ts" />
/// <reference path="../decl/three-orbitcontrols.d.ts" />
/// <reference path="../decl/dat-gui.d.ts" />
/// <reference path="appthreebase.ts" />

class AppThreeMaterials extends AppThreeBase {

    constructor() {
        super();
    }

    public main() {

        // kamera
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 5);

        this.createScene();
        this.addStats();

        this.addLights();
        this.addObjects();

        // prizbusobeni oknu
        this.registerResizeHandler();

        // vykresleni
        this.render();
    }

    /*
    Prida svetla do sceny. 
    */
    addLights() {
        // bodove svetlo
        var light = new THREE.DirectionalLight(0xffffff, 1);
        light.position.set(0.5, 0.5, 1);
        this.scene.add(light);
    }

    /*
    Prida objekty do sceny. 
    */
    addObjects() {

        var material = new THREE.MeshPhongMaterial({ map: THREE.ImageUtils.loadTexture("../img/FIM.png") });
        // kostka
        var cube = new THREE.Mesh(
            new THREE.BoxGeometry(1, 1, 1),
            material);
        cube.rotation.y = Math.PI / 6;

        this.scene.add(cube);
    }
}

window.onload = () => {
    var app = new AppThreeMaterials();
    app.main();
}; 