﻿/// <reference path="../decl/three.d.ts" />
/// <reference path="../decl/three-orbitcontrols.d.ts" />
/// <reference path="../decl/dat-gui.d.ts" />
/// <reference path="appthreebase.ts" />

class AppThreeObject extends AppThreeBase {

    constructor() {
        super();
    }

    public main() {

        // kamera
        this.camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.01, 200);
        this.camera.position.set(0, 0, 10);

        this.createScene();

        this.addStats();
        this.addLights();
        this.addObjects();

        // prizbusobeni oknu
        this.registerResizeHandler();
        this.render();
    }

    /*
    Prida svetla do sceny. 
    */
    addLights() {
        // rovnobezne svetlo
        var light = new THREE.DirectionalLight(0xffffff, 2);
        light.position.set(0.5, 0.5, 1);
        this.scene.add(light);

        var light2 = new THREE.DirectionalLight(0xffffff, 2);
        light2.position.set(0, 0, -1);
        this.scene.add(light2);
    }

    /*
    Prida objekty do sceny. 
    */
    addObjects() {
        var loader = new (<any>THREE).JSONLoader();

        loader.load('../objects/deer.json',(geometry, materials) => {
            var material = new THREE.MeshFaceMaterial(materials);
            var deer = new THREE.Mesh(geometry, material);
            deer.position.y = -2;
            deer.rotation.y = -Math.PI / 6;
            this.scene.add(deer);
        });

        var material = new THREE.MeshLambertMaterial({ color: 0x001900 });

        var geometry = new THREE.PlaneGeometry(6, 4);
        var plane = new THREE.Mesh(geometry, material);
        plane.position.y = -2;
        plane.rotation.x = - Math.PI / 2;
        this.scene.add(plane);
    }
}

window.onload = () => {
    var app = new AppThreeObject();
    app.main();
}; 