﻿class App {

    public main() {

        var canvas = <HTMLCanvasElement> document.getElementById('canvas');
        var gl = canvas.getContext("webgl") || canvas.getContext("experimental-webgl");

        var vertexShader = gl.createShader(gl.VERTEX_SHADER);
        var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);

        gl.shaderSource(vertexShader,
            'attribute vec2 position;' +
            'void main() {' +
            'gl_Position = vec4(position, 0.0, 1.0);' +
            'gl_PointSize = 10.0;' +
            '}');

        gl.shaderSource(fragmentShader,
            'void main() {' +
            'gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0);' +
            '}');

        gl.compileShader(vertexShader);
        gl.compileShader(fragmentShader);

        var shaderProgram = gl.createProgram();

        gl.attachShader(shaderProgram, vertexShader);
        gl.attachShader(shaderProgram, fragmentShader);

        gl.linkProgram(shaderProgram);
        gl.useProgram(shaderProgram);

        var location = gl.getAttribLocation(shaderProgram, "position");

        var vertexBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, vertexBuffer);
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0.0, 0.0]), gl.STATIC_DRAW);

        gl.clear(gl.COLOR_BUFFER_BIT);

        gl.vertexAttribPointer(location, 2, gl.FLOAT, false, 0, 0);
        gl.enableVertexAttribArray(location);
        gl.drawArrays(gl.POINTS, 0, 1);
    }
}

window.onload = () => {
    var app = new App();
    app.main();
};